MWAWPictBitmapContainer< T > Class Template Reference

a template class to store a 2D array of m_data More...

`#include <MWAWPictBitmap.hxx>`

## Public Member Functions

| MWAWPictBitmapContainer (Vec2i const &sz)
| constructor given size More...
virtual | ~MWAWPictBitmapContainer ()
| destructor More...
bool | ok () const
| returns ok, if the m_data is allocated More...
int | cmp (MWAWPictBitmapContainer< T > const &orig) const
| a comparison operator More...
Vec2i const & | size () const
| return the array size More...
int | numRows () const
| gets the number of row More...
int | numColumns () const
| gets the number of column More...
T const & | get (int i, int j) const
| accessor of a cell m_data More...
T const * | getRow (int j) const
| accessor of a row m_data More...
void | set (int i, int j, T const &v)
| sets a cell m_data More...
template<class U >
void | setRow (int j, U const *val)
| sets a line of m_data More...
template<class U >
void | setColumn (int i, U const *val)
| sets a column of m_data More...

## Protected Attributes

Vec2i | m_size
| the size More...
T * | m_data
| the m_data placed by row ie. d_00, d_10, ... , d_{X-1}0, .. More...

## Private Member Functions

| MWAWPictBitmapContainer (MWAWPictBitmapContainer const &orig)
MWAWPictBitmapContainer & | operator= (MWAWPictBitmapContainer const &orig)

## Detailed Description

### template<class T>
class MWAWPictBitmapContainer< T >

a template class to store a 2D array of m_data

## Constructor & Destructor Documentation

template<class T>

MWAWPictBitmapContainer< T >::MWAWPictBitmapContainer | ( | Vec2i const & | sz | ) |

inline

constructor given size

template<class T>

virtual MWAWPictBitmapContainer< T >::~MWAWPictBitmapContainer | ( |  | ) |

inline virtual

destructor

template<class T>

MWAWPictBitmapContainer< T >::MWAWPictBitmapContainer | ( | MWAWPictBitmapContainer< T > const & | orig | ) |

private

## Member Function Documentation

template<class T>

int MWAWPictBitmapContainer< T >::cmp | ( | MWAWPictBitmapContainer< T > const & | orig | ) | const

inline

a comparison operator

Referenced by MWAWPictBitmapIndexed::cmp(), and MWAWPictBitmapColor::cmp().

template<class T>

T const& MWAWPictBitmapContainer< T >::get | ( | int | i,
|  | int | j
| ) |  | const

inline

accessor of a cell m_data

Referenced by MWAWPictBitmapBW::get(), MWAWPictBitmapIndexed::get(), and MWAWPictBitmapColor::get().

template<class T>

T const* MWAWPictBitmapContainer< T >::getRow | ( | int | j | ) | const

inline

accessor of a row m_data

Referenced by getPBMData(), getPPMData(), MWAWPictBitmapBW::getRow(), MWAWPictBitmapIndexed::getRow(), and MWAWPictBitmapColor::getRow().

template<class T>

int MWAWPictBitmapContainer< T >::numColumns | ( |  | ) | const

inline

gets the number of column

Referenced by MWAWPictBitmapBW::numColumns(), MWAWPictBitmapIndexed::numColumns(), and MWAWPictBitmapColor::numColumns().

template<class T>

int MWAWPictBitmapContainer< T >::numRows | ( |  | ) | const

inline

gets the number of row

Referenced by MWAWPictBitmapBW::numRows(), MWAWPictBitmapIndexed::numRows(), and MWAWPictBitmapColor::numRows().

template<class T>

bool MWAWPictBitmapContainer< T >::ok | ( |  | ) | const

inline

returns ok, if the m_data is allocated

Referenced by MWAWPictBitmapBW::valid(), MWAWPictBitmapIndexed::valid(), and MWAWPictBitmapColor::valid().

template<class T>

MWAWPictBitmapContainer& MWAWPictBitmapContainer< T >::operator= | ( | MWAWPictBitmapContainer< T > const & | orig | ) |

private

template<class T>

void MWAWPictBitmapContainer< T >::set | ( | int | i,
|  | int | j,
|  | T const & | v
| ) |  |

inline

sets a cell m_data

Referenced by MWAWPictBitmapBW::set(), MWAWPictBitmapIndexed::set(), and MWAWPictBitmapColor::set().

template<class T>
template<class U >

void MWAWPictBitmapContainer< T >::setColumn | ( | int | i,
|  | U const * | val
| ) |  |

inline

sets a column of m_data

Referenced by MWAWPictBitmapBW::setColumn(), MWAWPictBitmapIndexed::setColumn(), and MWAWPictBitmapColor::setColumn().

template<class T>
template<class U >

void MWAWPictBitmapContainer< T >::setRow | ( | int | j,
|  | U const * | val
| ) |  |

inline

sets a line of m_data

Referenced by MWAWPictBitmapBW::setRow(), MWAWPictBitmapIndexed::setRow(), and MWAWPictBitmapColor::setRow().

template<class T>

Vec2i const& MWAWPictBitmapContainer< T >::size | ( |  | ) | const

inline

return the array size

Referenced by getPBMData(), getPPMData(), MWAWPictBitmapBW::size(), MWAWPictBitmapIndexed::size(), and MWAWPictBitmapColor::size().

## Member Data Documentation

template<class T>

T* MWAWPictBitmapContainer< T >::m_data

protected

the m_data placed by row ie. d_00, d_10, ... , d_{X-1}0, ..

Referenced by MWAWPictBitmapContainer< bool >::cmp(), MWAWPictBitmapContainerBool::cmp(), MWAWPictBitmapContainer< bool >::get(), MWAWPictBitmapContainer< bool >::getRow(), MWAWPictBitmapContainer< bool >::MWAWPictBitmapContainer(), MWAWPictBitmapContainer< bool >::ok(), MWAWPictBitmapContainer< bool >::set(), MWAWPictBitmapContainer< bool >::setColumn(), MWAWPictBitmapContainer< bool >::setRow(), and MWAWPictBitmapContainer< bool >::~MWAWPictBitmapContainer().

template<class T>

Vec2i MWAWPictBitmapContainer< T >::m_size

protected

the size

Referenced by MWAWPictBitmapContainer< bool >::cmp(), MWAWPictBitmapContainerBool::cmp(), MWAWPictBitmapContainer< bool >::get(), MWAWPictBitmapContainer< bool >::getRow(), MWAWPictBitmapContainer< bool >::MWAWPictBitmapContainer(), MWAWPictBitmapContainer< bool >::numColumns(), MWAWPictBitmapContainer< bool >::numRows(), MWAWPictBitmapContainer< bool >::set(), MWAWPictBitmapContainer< bool >::setColumn(), MWAWPictBitmapContainer< bool >::setRow(), and MWAWPictBitmapContainer< bool >::size().

The documentation for this class was generated from the following file:

- MWAWPictBitmap.hxx